<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class XMovieControllerCategories extends JController {
	
	function __construct($config = array()) {
		parent::__construct($config);
		$this->registerTask('unpublish', 'publish');
		$this->registerTask('apply', 'save');
		$this->registerTask('accessregistered', 'setAccess');
		$this->registerTask('accessspecial', 'setAccess');		
		$this->registerTask('accesspublic', 'setAccess');
	}
	
	function edit() {
		JRequest::setVar('view', 'category');
		//$this->checkOutCategory();
		$this->display();
	}

	function add() {
		JRequest::setVar('view', 'category');
		$this->display();
	}

	function save() {
		global $option, $mainframe;
		jimport('joomla.filesystem.file');
		JRequest::checkToken() or jexit('Invalid Token');
		$filename = "";
		$errors = "";
		$row =& JTable::getInstance('category', 'Table');
			
		if (!$row->bind(JRequest::get('post'))) {
			JError::raiseError(500, $row->getError());
		}
		
		if(!$row->check()) {
			JError::raiseError(500, 'NAME FIELD BLANK');
			return;
		}
		
		$input_thumbnail = JRequest::getVar('input_thumbnail', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if(isset($input_thumbnail) && $input_thumbnail != '') {
			$row->thumb = $input_thumbnail;
		}
		
		$max_system = ini_get('upload_max_filesize');

		//Retrieve file details from uploaded file, sent from upload form
		$file = JRequest::getVar('file_upload', null, 'files', 'array');
		
		if($file['size'] != 0 && $file['name'] != '' && $file['tmp_name'] != '') {
			if(!MediaHelper::isImage($file['tmp_name'])) {				
				$errors .= "<br/>".JTEXT::_('NOT AN IMAGE');
			} else {
			
				if($file['size'] > COM_XMOVIE_MAX_FILE_SIZE) {					
					$errors .= "<br/>".JTEXT::_('IMAGE TO LARGE');
				} else {			

					$name = pathinfo($file['name']);
					$filedate = time();				
 					$filename = $filedate . "." . $name['extension'];

					//Set up the source and destination of the file
					$src = $file['tmp_name'];
					$dest = COM_XMOVIE_BASE . DS . $filename;
			
					if ( !JFile::upload($src, $dest) ) {
      					$errors .= "<br/>".JTEXT::_('COULD NOT UPLOAD IMAGE');
   					} else {
   						$row->thumb = $filename;
   					}
				}				
			}
		}
		
		if($row->groupname == '') {
			$row->groupname = "Public";
		}
		
		$row->quicktake = JRequest::getVar('quicktake', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$row->description = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
			
		if (!$row->creation_date) {
			$row->creation_date = date('Y-m-d H:i:s');
		}

		if($row->ordering == '') {
			$row->ordering = XMovieMovieHelper::getNextCategoryOrder($row->pid);
		}
		
		if (!$row->store()) {
			JError::raiseError(500, $row->getError());
		}

		if($this->getTask() == 'apply') {
			$this->setRedirect('index.php?option='.$option.'&controller=categories&task=edit&id='.$row->id, JTEXT::_('CHANGES APPLIES').$errors);
		} else {
			//$this->checkInCategory();
			$this->setRedirect('index.php?option='.$option.'&controller=categories&view=categories', JTEXT::_('CATEGORY SAVED').$errors);
		}
	}
	
	function setAccess() {
		
		global $option;
		$cid = JRequest::getVar( 'cid', array());
		$id = (int)$cid[0];
		
		$row =& JTable::getInstance('category', 'Table');
		$row->load( $id );
		
		switch( $this->getTask()) {
			case 'accessspecial':
				$access = '2';
				$groupname = 'Special';
				break;
			case 'accessregistered':
				$access = '1';
				$groupname = 'Registered';
				break;
			default:
				$access = '0';
				$groupname = 'Public';
		}

		$row->access = $access;
		$row->groupname = $groupname;

		if ( !$row->check() ) {
			return $row->getError();
		}
		if ( !$row->store() ) {
			return $row->getError();
		}

		$this->setRedirect( 'index.php?option=' . $option.'&controller=categories&view=categories');
	}
	
	function publish() {
		JRequest::checkToken() or jexit('Invalid Token');
		global $option;
		$id = JRequest::getVar('cid', array());
		$db		=& JFactory::getDBO();
					
		$publish = 1;
			
		if($this->getTask() == 'unpublish') {
			$publish = 0;
		}
		
		$cids = implode( ',', $id );

		$query = 'UPDATE #__xmovie_categories'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '.$cids.' )';
		//. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $uid.' ) )'

		$db->setQuery( $query );
		if (!$db->query()) {
			JError::raiseError(500, $db->getErrorMsg() );
		}
		
		$s = '';
			
		if(count($id) >1) {
			$s = 's';
		}
			
		$msg = 'Category' . $s;
			
		if($this->getTask() == 'unpublish') {
			$msg .= JTEXT::_('UNPUBLISHED');
		} else {
			$msg .= JTEXT::_('PUBLISHED');
		}
			
		$this->setRedirect('index.php?option='.$option.'&controller=categories', $msg);
	}

	function remove() {
		JRequest::checkToken() or jexit('Invalid Token');
		global $option;
		$m = '';
			
		$ids = JRequest::getVar('cid', array(0));
		$row =& JTable::getInstance('category', 'Table');
			
		foreach($ids as $id) {
			$id = (int) $id;
			if($id != 1) {
				if(!$row->delete($id)) {
					JError::raiseError(500, $row->getError());
				}
			} else {
				$m = JTEXT::_('CANNOT DELETE MAIN CAT');
			}
		}
			
		$s = '';
		$resp = '';
			
		if(count($ids) > 1) {
			$resp = JTEXT::_('CATEGORIES DELETED');
		} else {
			$resp = JTEXT::_('CATEGORY DELETED');
		}
		
		if($m != '' && count($ids) == 1) {
			$resp = $m;
		} elseif($m != '' && count($ids) > 1) {
			$resp .= ' '.$m;
		}
			
		$this->setRedirect('index.php?option='. $option.'&controller=categories&view=categories', $resp);
	}
	
	function orderup() 	{
		$cid = JRequest::getVar( 'cid', array());
		$id = (int)$cid[0];
		
		$row =& JTable::getInstance('category', 'Table');
		$row->load( $id );
		$row->move(-1, ' pid = '.(int) $row->pid);

		$link = 'index.php?option=com_xmovie&controller=categories&view=categories';
		$this->setRedirect( $link );
	}

	function orderdown() 	{
		$cid = JRequest::getVar( 'cid', array());
		$id = (int)$cid[0];
		
		$row =& JTable::getInstance('category', 'Table');
		$row->load( $id );
		$row->move(1, ' pid = '.(int) $row->pid);
		
		$link = 'index.php?option=com_xmovie&controller=categories&view=categories';
		$this->setRedirect( $link );
	}
		
	function saveorder() {
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);
		
		$row =& JTable::getInstance('category', 'Table');
		$groupings = array();
		
		//$catid is null
		// update ordering values
		for( $i=0; $i < count($cid); $i++ ) {
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->pid;

			if ($row->ordering != $order[$i]) {
				
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('pid = '.(int) $group);
		}
		
		$msg = JText::_( 'New ordering saved' );
		$link = 'index.php?option=com_xmovie&controller=categories&view=categories';
		$this->setRedirect( $link, $msg  );
	}
	
	/*
	function checkOutCategory() {
		$user =& JFactory::getUser();
		$id = JRequest::getInt('id', 0);
		$row =& JTable::getInstance('category', 'Table');
		$row->load($id);
		$row->checkout($user->id);
		//echo printf(JText::_('RECORD CHECKED OUT'), $row->name, $user->name);
	}
	
	/*
	function checkOutCategory() {
		$user =& JFactory::getUser();
		$id = JRequest::getInt('id', 0);
		$row =& JTable::getInstance('category', 'Table');
		$row->load($id);
		$row->checkout($user->id);
		//echo printf(JText::_('RECORD CHECKED OUT'), $row->name, $user->name);
	}
	
	function checkInCategory() {
		$id = JRequest::getInt('id', 0);
		$row =& JTable::getInstance('category', 'Table');
		$row->load($id);
		$row->checkin($id);
		//echo printf(JText::_('RECORD CHECKED IN'), $row->name);
	}
	*/
	function display() {
		$view = JRequest::getVar('view');
		if (!$view) {
			JRequest::setVar('view', 'categories');
		}
		parent::display();
	}
}