<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class XMovieControllerMovies extends JController {
	
	function __construct($config = array()) {
		parent::__construct($config);
		$this->registerTask('unpublish', 'publish');
		$this->registerTask('apply', 'save');
		$this->registerTask('accessregistered', 'setAccess');
		$this->registerTask('accessspecial', 'setAccess');		
		$this->registerTask('accesspublic', 'setAccess');
	}

	function edit() {
		JRequest::setVar('view', 'movie');
		//$this->checkOutMovie();
		$this->display();
	}

	function add() {
		JRequest::setVar('view', 'movie');
		$this->display();
	}

	function save() {
		global $option, $mainframe;
		jimport('joomla.filesystem.file');
		JRequest::checkToken() or jexit('Invalid Token');
		$errors = '';
		$row =& JTable::getInstance('movie', 'Table');
			
		if (!$row->bind(JRequest::get('post'))) {
			JError::raiseError(500, $row->getError());
		}
		
		if(!$row->check()) {
			JError::raiseError(500, 'NAME FIELD BLANK');
			return;
		}
		
		$max_system = ini_get('upload_max_filesize');
		
		$input_thumbnail = JRequest::getVar('input_thumbnail', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if(isset($input_thumbnail) && $input_thumbnail != '') {
			$row->thumb = $input_thumbnail;
		}
		
		//Retrieve file details from uploaded file, sent from upload form
		$image = JRequest::getVar('image_upload', null, 'files', 'array');

		if($image['size'] != 0 && $image['name'] != '' && $image['tmp_name'] != '') {
			if(MediaHelper::isImage($image['type'])) {
				$errors .= "<br/>".JTEXT::_('NOT AN IMAGE');
			} else {
			
				if($image['size'] > COM_MAX_FILE_SIZE) {
					$errors .= "<br/>".JTEXT::_('IMAGE TO LARGE');
				} else {			

					$imagename = pathinfo($image['name']);
					$imagedate = time();				
 					$imagename = $imagedate . "." . $imagename['extension'];

					//Set up the source and destination of the file
					$src = $image['tmp_name'];
					$dest = COM_XMOVIE_BASE . DS . $imagename;
			
					if ( !JFile::upload($src, $dest) ) {
      					$errors .= "<br/>".JTEXT::_('COULD NOT UPLOAD IMAGE');
   					} else {
   						$row->thumb = $imagename;
   					}
				}				
			}
		}		
		
		//Retrieve file details from uploaded file, sent from upload form
		$file = JRequest::getVar('file_upload', null, 'files', 'array');

		if($file['size'] != 0 && $file['name'] != '' && $file['tmp_name'] != '') {
			if($file['size'] > COM_MAX_FILE_SIZE) {
				$errors .= "<br/>".JTEXT::_('MOVIE TO LARGE');
			} else {			

				$name = pathinfo($file['name']);
				$filedate = time();				
				$filename = $filedate . "." . $name['extension'];

				//Set up the source and destination of the file
				$src = $file['tmp_name'];
				$dest = COM_XMOVIE_FILE_BASE . DS . $filename;
			
				if ( !JFile::upload($src, $dest) ) {
   					$errors .= "<br/>".JTEXT::_('COULD NOT UPLOAD MOVIE');
				} else {
					$row->link = $filename;
				}
			}				
		}
		
		$embed_code = JRequest::getVar('embed_code', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if(!empty($embed_code) && $embed_code != '') {
			$embed_params = MediaHelper::parseEmbedString($embed_code);

			$row->width = $embed_params['width'];
			$row->height = $embed_params['height'];
			$row->link = $embed_params['src'];
			$row->flashvars = $embed_params['flashvars'];
			
			$full_link = parse_url($row->link);
			
			if($full_link['host'] == '') {
				if(JRequest::getVar('type') == 8) {
					$row->link = "http://www.watchme.tv" . $row->link;
				}
			}
		}
		
		if($row->cid == '') {
			$row->cid = 1;
		}

		if($row->groupname == '') {
			$row->groupname = "Public";
		}
		
		if(JRequest::getVar('ctask') == 'add') {
			$user =& JFactory::getUser();
			$row->submitter = $user->id;
		}
		
		if($row->time == '') {
			$row->time = '00:00';
		}
			
		$row->quicktake = JRequest::getVar('quicktake', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$row->description = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
			
		if (!$row->creation_date) {
			$row->creation_date = date('Y-m-d H:i:s');
		}
		
		if($row->ordering == '') {
			$row->ordering = XMovieMovieHelper::getNextMovieOrder($row->cid);
		}
		
		if (!$row->store()) {
			JError::raiseError(500, $row->getError());
		}

		if($this->getTask() == 'apply') {
			$this->setRedirect('index.php?option='.$option.'&task=edit&controller=movies&id='.$row->id, JTEXT::_('CHANGES APPLIES').$errors);
		} else {
			//$this->checkInMovie();
			$this->setRedirect('index.php?option='.$option.'&controller=movies&view=movies', JTEXT::_('MOVIE SAVED').$errors);
		}
			
	}
	
	function setAccess() {
		
		global $option;

		$cid = JRequest::getVar( 'cid', array());
		$id = (int)$cid[0];
		
		$row =& JTable::getInstance('movie', 'Table');
		$row->load( $id );
		
		switch( $this->getTask()) {
			case 'accessspecial':
				$access = '2';
				$groupname = 'Special';
				break;
			case 'accessregistered':
				$access = '1';
				$groupname = 'Registered';
				break;
			default:
				$access = '0';
				$groupname = 'Public';
		}

		$row->access = $access;
		$row->groupname = $groupname;

		if ( !$row->check() ) {
			return $row->getError();
		}
		if ( !$row->store() ) {
			return $row->getError();
		}

		$this->setRedirect( 'index.php?option=' . $option.'&controller=movies&view=movies');
	}

	function publish() {
		JRequest::checkToken() or jexit('Invalid Token');
		global $option;
		$id = JRequest::getVar('cid', array());
		$db		=& JFactory::getDBO();
			
		$publish = 1;
			
		if($this->getTask() == 'unpublish') {
			$publish = 0;
		}
		
		$cids = implode( ',', $id );

		$query = 'UPDATE #__xmovie_movies'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '.$cids.' )';
		//. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $uid.' ) )'

		$db->setQuery( $query );
		if (!$db->query()) {
			JError::raiseError(500, $db->getErrorMsg() );
		}	
					
		$s = '';
			
		if(count($id) >1) {
			$s = 's';
		}
			
		$msg = JTEXT::_('MOVIE') . $s;
			
		if($this->getTask() == 'unpublish') {
			$msg .= JTEXT::_('UNPUBLISHED');
		} else {
			$msg .= JTEXT::_('PUBLISHED');
		}
			
		$this->setRedirect('index.php?option='.$option.'&controller=movies', $msg);
	}
	
	function remove() {
		JRequest::checkToken() or jexit('Invalid Token');
		global $option;
			
		$ids = JRequest::getVar('cid', array(0));
		$row =& JTable::getInstance('movie', 'Table');
			
		foreach($ids as $id) {
			$id = (int) $id;

			if(!$row->delete($id)) {
				JError::raiseError(500, $row->getError());
			}
		}
			
		$s = '';
			
		if(count($ids) > 1) {
			$s = 's';
		}
			
		$this->setRedirect('index.php?option='. $option.'&controller=movies&view=movies', JTEXT::_('MOVIE') . $s . JTEXT::_('DELETED'));
	}
	
	function checkOutMovie() {
		$user =& JFactory::getUser();
		$id = JRequest::getInt('id', 0);
		$row =& JTable::getInstance('movie', 'Table');
		$row->load($id);
		$row->checkout($user->id);
		echo printf(JText::_('RECORD CHECKED OUT'), $row->name, $user->name);
	}
	
	function checkInMovie() {
		$id = JRequest::getInt('id', 0);
		$row =& JTable::getInstance('movie', 'Table');
		$row->load($id);
		$row->checkin($id);
		echo printf(JText::_('RECORD CHECKED IN'), $row->name);
	}
	
	function orderup() 	{
		global $option;
		$cid = JRequest::getVar( 'cid', array());
		$id = (int)$cid[0];
		
		$row =& JTable::getInstance('movie', 'Table');
		$row->load( $id );
		$row->move(-1, ' cid = '.(int) $row->cid);

		$link = 'index.php?option='. $option.'&controller=movies&view=movies';
		$this->setRedirect( $link );
	}

	function orderdown() 	{
		global $option;
		$cid = JRequest::getVar( 'cid', array());
		$id = (int)$cid[0];
		
		$row =& JTable::getInstance('movie', 'Table');
		$row->load( $id );
		$row->move(1, ' cid = '.(int) $row->cid);
		
		$link = 'index.php?option='. $option.'&controller=movies&view=movies';
		$this->setRedirect( $link );
	}
		
	function saveorder() {
		global $option;
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);
		
		$row =& JTable::getInstance('movie', 'Table');
		$groupings = array();
		
		//$catid is null
		// update ordering values
		$count = count($cid);
		
		for( $i=0; $i < $count; $i++ ) {
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->cid;
			
			if ($row->ordering != $order[$i]) {
				
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('cid = '.(int) $group);
		}
		
		$msg = JText::_( 'New ordering saved' );
		$link = 'index.php?option='. $option.'&controller=movies&view=movies';
		$this->setRedirect( $link, $msg  );
	}

	function display() {
		$view = JRequest::getVar('view');
		if (!$view) {
			JRequest::setVar('view', 'movies');
		}
		parent::display();
	}
}