<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class XMovieModelMain extends JModel {
	
	function getSearchPlugin() {
		$plugin = JPluginHelper::getPlugin("search", "xmovie");
		
		if(!JPluginHelper::isEnabled("search", "xmovie")) {
			$result = Array('ok' => false, 'mesg' => JText::_('SEARCH NOT ENABLED'));
			return $result;
		} else {
			$result = Array('ok' => true, 'mesg' => JText::_('SEARCH ENABLED'));
			return $result;
		}
	}
	
	function getXMovieFCE() {		
		$query = "SELECT * FROM #__modules WHERE module='mod_xmovie_fce'";
		$db =& JFactory::getDBO();
		$db->setQuery($query);
		$db->query();
		$num_rows = $db->getNumRows();

		if($num_rows > 0) {
			$result = Array('ok' => true, 'mesg' => JText::_('FCE INSTALLED'));
			return $result;
		} else {
			$result = Array('ok' => false, 'mesg' => JText::_('FCE NOT INSTALLED'));
			return $result;
		}
	}
	
	function getXMovieJScroller() {		
		$query = "SELECT * FROM #__modules WHERE module='mod_xmovie_jscroller'";
		$db =& JFactory::getDBO();
		$db->setQuery($query);
		$db->query();
		$num_rows = $db->getNumRows();
		
		if($num_rows > 0) {
			$result = Array('ok' => true, 'mesg' => JText::_('JSCROLLER INSTALLED'));
			return $result;
		} else {
			$result = Array('ok' => false, 'mesg' => JText::_('JSCROLLER NOT INSTALLED'));
			return $result;
		}
	}
	
	function getXMovieMenu() {		
		$query = "SELECT * FROM #__modules WHERE module='mod_xmovie_menu'";
		$db =& JFactory::getDBO();
		$db->setQuery($query);
		$db->query();
		$num_rows = $db->getNumRows();

		if($num_rows > 0) {
			$result = Array('ok' => true, 'mesg' => JText::_('MENU INSTALLED'));
			return $result;
		} else {
			$result = Array('ok' => false, 'mesg' => JText::_('MENU NOT INSTALLED'));
			return $result;
		}		
	}
	
	function getShadowbox() {		
		$plugin = JPluginHelper::getPlugin("system", "shadowbox");
		
		if(!JPluginHelper::isEnabled("system", "shadowbox")) {
			$result = Array('ok' => false, 'mesg' => JText::_('SHADOWBOX NOT ENABLED'));
			return $result;
		} else {
			$result = Array('ok' => true, 'mesg' => JText::_('SHADOWBOX ENABLED'));
			return $result;
		}
	}
	
	function getMovieLocation() {
		jimport('joomla.filesystem.file');
		$helper = new MovieHelper();
		$cookieParams = $helper->getCookieParams();
		
		$config = JFactory::getConfig();
		
		$component = JComponentHelper::getComponent( 'com_xmovie' );
  		$cfgParams = new JParameter( $component->params );
		
		if($cfgParams->get('image_external')) {
			$bpath = $cookieParams->bpath;
		} else {
			$bpath = COM_XMOVIE_BASE;
		}		

		if(!JFolder::exists($bpath)) {
			$result = Array('ok' => false, 'mesg' => JText::_('MOVIE PATH NOT EXIST'));
			return $result;
		}
		
		if(is_writable($bpath)) {
			$result = Array('ok' => true, 'mesg' => JText::_('MOVIE PATH WRITABLE'));
			return $result;
		} else {
			$result = Array('ok' => false, 'mesg' => JText::_('MOVIE PATH NOT WRITABLE'));
			return $result;
		}
	}	
	
	function getCategory() {
		$query = "SELECT * FROM #__xmovie_categories ORDER BY hits desc LIMIT 10";
		$cdata = $this->_getList($query);
				
		return $cdata;
	}
	
	function getViewedMovie() {
		$query = "SELECT * FROM #__xmovie_movies ORDER BY hits desc LIMIT 10";
		$cdata = $this->_getList($query);
		
		return $cdata;
	}
	
	function getNewMovie() {
		$query = "SELECT * FROM #__xmovie_movies ORDER BY creation_date desc LIMIT 10";
		$cdata = $this->_getList($query);
		
		return $cdata;
	}
	
	function getComponentInfo() {
		$info = array();
		//Retreive version from install file
		$parser		=& JFactory::getXMLParser('Simple');
		$xml		= JPATH_COMPONENT . DS . 'xmovie.xml';

		$parser->loadFile( $xml );
		$doc		=& $parser->document;
		
		$element	=& $doc->getElementByPath( 'author' );
		$info['author'] = $element->data();
		
		$element	=& $doc->getElementByPath( 'version' );
		$info['version'] = $element->data();
		
		$element	=& $doc->getElementByPath( 'copyright' );
		$info['copyright'] = $element->data();
		
		$element	=& $doc->getElementByPath( 'authorurl' );
		$info['authorurl'] = $element->data();
		
		$element	=& $doc->getElementByPath( 'license' );
		list($link, $gpl) = explode(' ', $element->data());
		$info['gpl'] = $gpl;
		$info['gpllink'] = $link;
		
		return $info;		
	}
}