<?php 
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die ('Restricted access');
jimport('joomla.application.component.model');

class XMovieModelRss extends JModel {
	var $_id = null;
	var $_cat_ids = null;
	var $_max_items = null;
	var $_query = null;
	var $_show_protected = null;
	var $_catslug = null;
	var $_movslug = null;
	
	function __construct() {
		parent::__construct();
		
		global $mainframe, $option;
		$cfgParams = &JComponentHelper::getParams( 'com_xmovie' );
		
		$this->_max_items = $cfgParams->get('rss_max_items');

		$this->_show_protected = $cfgParams->get('rss_show_protected', 0);
				
	}
	
	function &getData() {			
		global $option;
		$this->_id = JRequest::getInt('id', 1);
		
		if(empty($this->_data)) {
			if($this->_id == '') {
				$this->_query = $this->_buildSearch();
			} else {
				$this->_query = $this->buildSearchWithId();
			}
			
			$this->_data = $this->_getList($this->_query);
		}
		
		if(!$this->_catslug) {
			$this->_catslug = MovieHelper::getCategorySlug();
		}
		
		if(!$this->_movslug) {
			$this->_movslug = MovieHelper::getMovieSlug();
		}
		
		$count = count($this->_data);
		for($i = 0; $i < $count; $i++) {
			$this->_data[$i]->slug = $this->_data[$i]->id . ':' . $this->_movslug;
			$this->_data[$i]->catslug = $this->_data[$i]->cid . ':' . $this->_catslug;
			$user =& JFactory::getUser($this->_data[$i]->submitter);
			$this->_data[$i]->submitter = $user->username;
		}

		return $this->_data;
		
	}
	
	function _buildSearch() {
		global $mainframe;

		if(!$this->_cat_ids) {
			$this->_cat_ids = $this->_getMovCategories();
		}
		
		if (!$this->_query) {
			/*$this->_query =  "SELECT #__xgallery.id AS id, #__xgallery.cid AS cid, #__xgallery.name AS name,";
			$this->_query .= " #__xgallery.thumb AS thumb, #__xgallery.hits AS hits, #__xgallery.creation_date AS creation_date,";
			$this->_query .= " #__xgallery.folder AS folder, #__xgallery.quicktake AS quicktake, #__xgallery.description AS description,";
			$this->_query .= " #__xgallery.groupname AS groupname";
			$this->_query .= " FROM #__xgallery, #__xgallery_categories";
			$this->_query .= " WHERE #__xgallery.published = '1' AND #__xgallery_categories.published = '1'";
			$this->_query .= " AND #__xgallery.cid = #__xgallery_categories.id";*/		

			$this->_query =  "SELECT #__xmovie_movies.id AS id, #__xmovie_movies.cid AS cid, #__xmovie_movies.name AS name,";
			$this->_query .= " #__xmovie_movies.thumb AS thumb, #__xmovie_movies.hits AS hits, #__xmovie_movies.creation_date AS creation_date,";
			$this->_query .= " #__xmovie_movies.time as time, #__xmovie_movies.quicktake AS quicktake, #__xmovie_movies.description AS description,";
			$this->_query .= " #__xmovie_movies.submitter as submitter, #__xmovie_movies.groupname AS groupname";
			$this->_query .= " FROM #__xmovie_movies, #__xmovie_categories";
			$this->_query .= " WHERE #__xmovie_movies.published = '1' AND #__xmovie_categories.published = '1'";
			$this->_query .= " AND #__xmovie_movies.cid = #__xmovie_categories.id";
			
			if(count($this->_cat_ids) > 0) {
				$catlist = array();
				foreach($this->_cat_ids as $catId) {
					$catlist[] = " cid='{$catId}'";					
				}	
				$this->_query .= ' AND ('. implode(' OR ', $catlist).')';				
			}
			
			$this->_query .= MovieHelper::getAccessLevelCC();
		}
		
		$this->_query .= " ORDER BY creation_date DESC";
		$this->_query .= " LIMIT {$this->_max_items}";
		
		
		return $this->_query;
	}
	
	function buildSearchWithId() {
		if (!$this->_query) {
			
			if(!$this->_cat_ids) {
				$this->_cat_ids = $this->_getMovCategories();
			}
			
			/*$this->_query =  "SELECT DISTINCT #__xgallery.id AS id, #__xgallery.cid AS cid, #__xgallery.name AS name,";
			$this->_query .= " #__xgallery.thumb AS thumb, #__xgallery.hits AS hits, #__xgallery.creation_date AS creation_date,";
			$this->_query .= " #__xgallery.folder AS folder, #__xgallery.quicktake AS quicktake, #__xgallery.description AS description,";
			$this->_query .= " #__xgallery.groupname AS groupname";
			$this->_query .= " FROM #__xgallery, #__xgallery_categories";
			$this->_query .= " WHERE #__xgallery.published = '1' AND #__xgallery_categories.published = '1'";*/

			$this->_query =  "SELECT DISTINCT #__xmovie_movies.id AS id, #__xmovie_movies.cid AS cid, #__xmovie_movies.name AS name,";
			$this->_query .= " #__xmovie_movies.thumb AS thumb, #__xmovie_movies.hits AS hits, #__xmovie_movies.creation_date AS creation_date,";
			$this->_query .= " #__xmovie_movies.time as time, #__xmovie_movies.quicktake AS quicktake, #__xmovie_movies.description AS description,";
			$this->_query .= " #__xmovie_movies.submitter as submitter, #__xmovie_movies.groupname AS groupname";
			$this->_query .= " FROM #__xmovie_movies, #__xmovie_categories";
			$this->_query .= " WHERE #__xmovie_movies.published = '1' AND #__xmovie_categories.published = '1'";
			
			if(count($this->_cat_ids) > 0) {
				$catlist = array();
				foreach($this->_cat_ids as $catId) {
					$catlist[] = " cid='{$catId}'";					
				}	
				$this->_query .= ' AND ('. implode(' OR ', $catlist).')';				
			}

		
			$this->_query .= MovieHelper::getAccessLevelCC();
			$this->_query .=  " ORDER BY creation_date DESC";
			$this->_query .= " LIMIT {$this->_max_items}";
		}

		return $this->_query;
	}
	
	/**
	 *  Function to get all sub cagegories in the current categories that is allowed for the 
	 *  visitors access level.
	 *  
	 *  @return catids The sub category ids
	 */
	function _getMovCategories() {
		$catids = array();
		$rows = array();
		$access = MovieHelper::getAccessLevel();

		if(empty($this->_cat_ids)) {

			$catids[] = $this->_id;
			$query = "SELECT id FROM #__xmovie_categories WHERE published = '1' AND pid= {$this->_id}".$access;
			$db =& JFactory::getDBO();
			$db->setQuery($query);
			$rows = $db->loadResultArray();

			while(count($rows) > 0) {
				$catArray = array();				
				
				foreach($rows as $row) {
					$catids[] = $row;
					$catArray[] = " pid='{$row}'";					
				}
				
				$query = "SELECT id FROM #__xmovie_categories WHERE published = '1'";
				if(count($catArray) > 0) {
					$query .= ' AND ('. implode(' OR ', $catArray).')';
				}
				$query .= $access;
				$db->setQuery($query);
				$rows = array();
				$rows = $db->loadResultArray();
			}	
		} 	

		if(count($catids) > 0) {
			$this->_cat_ids = $catids;
		}
		
		return $this->_cat_ids;
	}
	
}