<?php 
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die ('Restricted access');
jimport('joomla.application.component.model');
	
class XMovieModelSingle extends JModel {
	var $_data = null;
	var $_pagination = null;
	var $_total = null;
	var $_query = null;
	var $_search = null;
	var $_cat = null;
	var $_catname = null;
	var $_component_id = null;
		
	function &getData() {		
		global $mainframe, $option;
				
		$id = (int) JRequest::getVar('id');
		$movie =& JTable::getInstance('movie', 'Table');
		$movie->load($id);
		
		MovieHelper::checkAccessLevel( $movie->cid );
		MovieHelper::checkMovieAccess( $movie->id );
		
		$movie->hit( $id );
		$this->_data = $movie;
		$this->_cat = $movie->cid;
		$this->_component_id = $this->_getComponentID();
		return $this->_data;
	}
	
	function buildSearch() {
		if (!$this->_query) {
			$search = $this->getSearch();
			$id = JRequest::getInt('id');
			
			$this->_query =  "SELECT #__xmovie_movies.id AS id, #__xmovie_movies.cid AS cid, #__xmovie_movies.name AS name,";
			$this->_query .= " #__xmovie_movies.thumb AS thumb, #__xmovie_movies.hits AS hits, #__xmovie_movies.creation_date AS creation_date,";
			$this->_query .= " #__xmovie_movies.time as time, #__xmovie_movies.description AS description,";
			$this->_query .= " #__xmovie_movies.submitter as submitter, #__xmovie_movies.groupname AS groupname";
			$this->_query .= " FROM #__xmovie_movies, #__xmovie_categories";
			$this->_query .= " WHERE #__xmovie_movies.published = '1' AND #__xmovie_categories.published = '1'";
			$this->_query .= " AND #__xmovie.cid = #__xmovie_categories.id";
			$this->_query .= " AND #__xmovie.id ='{$id}'";
						
			if ($search != '') {
				$fields = array('name', 'quicktake', 'description');

				$where = array();

				$search = $this->_db->getEscaped( $search, true );

				foreach ($fields as $field) {
					$where[] = $field . " LIKE '%{$search}%'";
				}

				$this->_query .= ' WHERE (' . implode(' OR ', $where).')';
			}

			$this->_query .=  MovieHelper::getAccessLevelCC();
			$this->_query .=  " LIMIT 1";
		}

		return $this->_query;
	}
		
	function getCatName() {
		if (!$this->_catname) {
			$query = "SELECT id, name FROM #__xmovie_categories WHERE published = '1' AND id ='{$this->_cat}' LIMIT 1";
			$row = $this->_getList($query);
			$this->_catname = $row[0];
		}
		
		return $this->_catname;
	}
	
	function getBreadcrumbs() {
		global $mainframe;
		jimport('joomla.environment.uri');

		$com = JComponentHelper::getComponent('com_xmovie');
		$db =& JFactory::getDBO();		
		$query = "SELECT id, name, link FROM #__menu WHERE published = '1' AND componentid='{$com->id}' AND link LIKE '%main%'";		
		$db->setQuery($query);
		$main = $db->loadRow();
		$catalias = MovieHelper::getCategorySlug();

		$menu = $this->_getMenuItems();
		$pathway = &$mainframe->getPathway();
		$breadcrumbs = $pathway->getPathway();
		
		$currid = MovieHelper::getComponentId();
		
		if($currid->id == $this->getComponentID()) {
			if(isset($main)) {
				unset($pathway->_pathway);
				$pathway->addItem($main[1], JRoute::_($main[2].'&amp;Itemid='.$main[0]));
			}		
		
			$breadcrumbs = $pathway->getPathway();
	
			if(count($breadcrumbs) > 0) {
				$count = count($breadcrumbs) - 1;
	
				$currURI =& JURI::getInstance($breadcrumbs[$count]->link);
				$itemid = $currURI->getVar('Itemid');
				if(!$itemid) {
					$itemid = $main[0];
				}
				
				if($this->_data->cid != 1) {
					$catName = $this->getCatName();

					$link = JRoute::_('index.php?option=com_xmovie&view=category&id='.$catName->id.':'.$catalias.'&Itemid='.$itemid);
					$pathway->addItem($catName->name, $link);
				}

				$pathway->addItem($this->_data->name, '');
			}
		}
	}

	function getComponentID() {
		return $this->_component_id;
	}
	
	function _getComponentID() {
		$com = JComponentHelper::getComponent('com_xmovie');

		$db =& JFactory::getDBO();		
		$query = "SELECT id FROM #__menu WHERE published = '1' AND componentid='{$com->id}'";		
		$db->setQuery($query);
		$id = $db->loadResult();
		
		return $id;
	}
	
	function _getMenuItems() {
		jimport('joomla.environment.uri');
		$com = JComponentHelper::getComponent('com_xmovie');
		$query = "SELECT id, link, parent FROM #__menu WHERE published = '1' AND componentid='{$com->id}' AND sublevel != '0'";		
		$links = $this->_getList($query);
		$where = array();

		if(count($links) > 0) {
			foreach($links as $link) {				
				$currURI = JURI::getInstance($link->link);
				if($currURI->getVar('id') == $this->_cat) {					
					return $link->id;
				}
			}
		}
		
		return $where;
	}
	
	function getMenuCategories() {
		jimport('joomla.environment.uri');
		$com = JComponentHelper::getComponent('com_xmovie');

		$query = "SELECT id, link, parent FROM #__menu WHERE published = '1' AND componentid='{$com->id}' AND sublevel != '0'";		
		$links = $this->_getList($query);
		$where = array();

		if(count($links) > 0) {
			foreach($links as $link) {				
				$currURI = JURI::getInstance($link->link);
				if($currURI->getVar('id') == $this->_cat) {					
					return $link->id;
				}
			}
		}
		
		return $where;
	}
		
	function getTotal() {
		if (!$this->_total) {
			$query = $this->buildSearch();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
		
	function getSearch()
	{
		if (!$this->_search) {
			global $mainframe, $option;

			$search = $mainframe->getUserStateFromRequest( "$option.search", 'search', '', 'string' );
			$this->_search = JString::strtolower($search);
		}

		return $this->_search;
	}
}
?>

