<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');

JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_xmovie'.DS.'tables');
	
class XMovieViewRss extends JView {
	function display($tpl = null) {
		global $mainframe;
				
		$component = JComponentHelper::getComponent( 'com_xmovie' );
  		$cfgParams = new JParameter( $component->params );
  		$compId = MovieHelper::getXMovieItemId();
		$movies = $this->get('data');
		
		$id = JRequest::getInt('id', '');
		$document =& JFactory::getDocument();
				
		// set feed title
		$document->setTitle($cfgParams->get('rss_title'));
		$document->setLink(JRoute::_('index.php?option=com_xmovie&view=main'));
		
		foreach($movies as $movie) {
			// create feed item
			$item = new JFeedItem();

			$item->title = $movie->name;
			$imageThumb = parse_url($movie->thumb);
							
			if(!isset($imageThumb['host']) || $imageThumb['host'] == '') {
				$movString = JURI::base(true)."components/com_xmovie/helpers/img.php?file=".urlencode($movie->thumb)."&t=m";													
			} else {
				$movString = $movie->thumb;						
			}
			
			$link = JRoute::_("index.php?option=com_xmovie&view=single&catid={$movie->catslug}&id={$movie->slug}&Itemid={$compId->id}");
			$linkfull = JURI::base(true).$link;
			$item->link = $linkfull;			
			$img = '<img src="'.$movString.'" width="'.$cfgParams->get('cview_mov_width', 75).'" alt="'.htmlspecialchars($movie->name).'" />';
			$thumb = "<a href='{$linkfull}'>{$img}</a>";
			$item->description = $thumb.$movie->quicktake;
			$item->date = date('r', strtotime($movie->creation_date));
			$item->pubDate = time();

			$document->addItem($item);
		}
		
		
	}
}
